/*
----------------------------------------
	ECALL.H: MicroEMACS 3.10
----------------------------------------
*/

/*
----------------------------------------
	RCS id : $Id: ecall.h,v 1.3.1.4 1996/04/06 05:57:43 sharl Exp $
----------------------------------------
*/

/*
----------------------------------------
	DOS R[̒`
----------------------------------------
*/

#define _MAX_DRIVE	2
#define	_MAX_PATH	65
#define	_MAX_NAME1	8
#define	_MAX_NAME2	10
#define	_MAX_NAME	(_MAX_NAME1 + _MAX_NAME2 + 1)
#define	_MAX_EXTEND	5
#define	_MAX_FILENAME	(_MAX_NAME + _MAX_EXTEND - 1)

struct FREEINF
  {
    unsigned short free, max;
    unsigned short sec, byte;
  };

struct FILBUF
  {
    char os[21];
    char atr;
    short time, date;
    int filelen;
    char name[_MAX_FILENAME];
  };

struct NAMESTBUF
  {
    char flg, drive;
    char path[_MAX_PATH];
    char name1[_MAX_NAME1];
    char ext[3], name2[_MAX_NAME2];
  };

/* from myu header */
struct NAMECKBUF
  {
    char   drive[_MAX_DRIVE];
    char   path[_MAX_PATH];
    char   name[_MAX_NAME];
    char   ext[_MAX_EXTEND];
  };

int C_FNKMOD (int);
int C_WIDTH (int);
int KFLUSHIO (int);
int K_KEYBIT (int);
int K_KEYINP (void);
int K_KEYSNS (void);
int K_SFTSNS (void);
void FNCKEYGT (int, char *);
void FNCKEYST (int, char *);
void K_INSMOD (int);

#ifndef __DOS_INLINE
int BREAKCK (int);
void CHANGE_PR (void);
int CHGDRV (int);
int CHMOD (char *, int);
int CLOSE (int);
int CREATE (char *, int);
int CURDRV (void);
int DELETE (char *);
int DSKFRE (int, struct FREEINF *);
int FILES (struct FILBUF *, char *, int);
int GETDATE (void);
int GETENV (char *, char *, char *);
int GETTIME (void);
void (*INTVCS (int, void (*) (void))) (void);
int KEYSNS (void);
int NAMECK (char *, struct NAMECKBUF *);
int NAMESTS (char *, struct NAMESTBUF *);
int NFILES (struct FILBUF *);
int OPEN (char *, int);
int READ (int, char *, int);
int SEEK (int, int, int);
int SETENV (char *, char *, char *);
int VERNUM (void);
long WAIT (void);
int WRITE (int, char *, int);
#else
DOSCALL	long BREAKCK(short); 										/* FF33 */
DOSCALL	void CHANGE_PR(void);										/* FFFF */
DOSCALL long CHGDRV (short);										/* FF0E */
DOSCALL	long CHMOD(const char *, short);						 	/* FF43 */
DOSCALL long CLOSE (short);											/* FF3E */
DOSCALL long CREATE (char *, short);								/* FF3C */
DOSCALL long CURDRV (void);											/* FF19 */
DOSCALL long DELETE (char *);										/* FF41 */
DOSCALL long DSKFRE (short, struct FREEINF *);						/* FF36 */
DOSCALL	long FILES(struct FILBUF *, const char *, short);			/* FF4E */
DOSCALL long GETDATE (void);										/* FF2A */
DOSCALL long GETENV (char *, char *, char *);						/* FF53 */
DOSCALL unsigned short GETTIME (void);								/* FF2C */
DOSCALL void (*INTVCS (unsigned short, void (*) (void))) (void);	/* FF25 */
DOSCALL	long KEYSNS(void);											/* FF0B */
DOSCALL	long NAMECK(const char *, struct NAMECKBUF *);				/* FF37 */
DOSCALL	long NAMESTS(const char *, struct NAMESTBUF *);				/* FF29 */
DOSCALL	long NFILES(struct FILBUF *);								/* FF4F */
DOSCALL	long OPEN(const char *, short);							 	/* FF3D */
DOSCALL long READ (short, void *, long);							/* FF3F */
DOSCALL	long SEEK(short, long, short);								/* FF42 */
DOSCALL long SETENV (char *, char *, char *);						/* FF52 */
DOSCALL long VERNUM (void);											/* FF30 */
DOSCALL long WAIT (void);											/* FF4D */
DOSCALL	long WRITE(short, const void *, long);						/* FF40 */
#endif

/*
----------------------------------------
	IOCS R[̒`
----------------------------------------
*/

struct XLINEPTR
  {
    short vram_page;
    short x, y, x1;
    short line_style;
  };

struct YLINEPTR
  {
    short vram_page;
    short x, y, y1;
    short line_style;
  };

#ifndef __IOCS_INLINE
int B_SFTSNS (void);
int B_BPEEK (int);
int B_COLOR (int);
int B_CONSOL (int, int, int, int);
int B_LOCATE (int, int);
int B_PRINT (char *);
int B_PUTC (int);
int B_PUTMES (int, int, int, int, char *);
int B_WPOKE (int, short);
int CRTMOD (int);
int MS_CURGT (void);
int MS_CURST (int, int);
int MS_GETDT (void);
int MS_LIMIT (int, int, int, int);
int ONTIME (void);
int SKEY_MOD (int, int, int);
int TPALET (int, int);
int TPALET2 (int, int);
void B_CLR_AL (void);
void LEDMOD (int, int);
void MS_CUROF (void);
void MS_CURON (void);
void MS_INIT (void);
void OS_CUROF (void);
void OS_CURON (void);
void TXXLINE (struct XLINEPTR *);
void TXYLINE (struct YLINEPTR *);
void TXRASCPY (int, int, int);

#else

/***********************************************************/
#define VOID_VOID(funcname, num)							\
static __inline__ void funcname(void) {						\
	asm volatile ("moveq.l #" #num ",d0\n\t"				\
			"trap #15"										\
			: /* no outputs */								\
			: /* no inputs */								\
			: "d0");										\
}

#define VOID_UNI_A1(funcname, argtype, arg, num)			\
static __inline__ void funcname(argtype arg) {				\
    asm volatile ("move.l %0,a1\n\t"						\
		      "moveq.l #" #num ",d0\n\t"					\
		      "trap #15"									\
			: /* no outputs */								\
			: "g" (arg)										\
			: "d0", "a1");									\
}

#define VOID_UNI_D1(funcname, argtype, arg, num)			\
static __inline__ void funcname(argtype arg) {				\
    asm volatile ("move.l %0,d1\n\t"						\
		      "moveq.l #" #num ",d0\n\t"					\
		      "trap #15"									\
			: /* no outputs */								\
			: "ri" (arg)									\
			: "d0", "d1");									\
}

#define TYPE_VOID(rettype, funcname, num)					\
static __inline__ rettype funcname(void) {					\
	register unsigned int d0 asm("d0");						\
	asm volatile ("moveq.l #" #num ",%0\n\t"				\
			"trap #15"										\
			: "=d" (d0)										\
			: /* no inputs */ );							\
    return d0;												\
}

#define TYPE_UNI_A1(rettype, funcname, argtype, arg, num)	\
static __inline__ rettype funcname(argtype arg) {			\
    register unsigned int d0 asm("d0");						\
    asm volatile ("move.l %1,a1\n\t"						\
		      "moveq.l #" #num ",%0\n\t"					\
		      "trap #15"									\
			: "=d" (d0)										\
			: "g" (arg)										\
			: "a1");										\
    return d0;												\
}

#define TYPE_UNI_D1(rettype, funcname, argtype, arg, num)	\
static __inline__ rettype funcname(argtype arg) {			\
    register unsigned int d0 asm("d0");						\
    asm volatile ("move.l %1,d1\n\t"						\
		      "moveq.l #" #num ",%0\n\t"					\
		      "trap #15"									\
			: "=d" (d0)										\
			: "ri" (arg)									\
			: "d1");										\
    return d0;												\
}

#define TYPE_DI_D1D2(rettype, funcname, argt1, arg1, argt2, arg2, num)	\
static __inline__ rettype funcname(argt1 arg1, argt2 arg2) {			\
    register unsigned int d0 asm("d0");									\
    asm volatile ("move.l %1,d1\n\t"									\
		      "move.l %2,d2\n\t"										\
		      "moveq.l #" #num ",%0\n\t"								\
		      "trap #15"												\
			: "=d" (d0)													\
			: "ri" (arg1), "ri" (arg2)									\
			: "d1", "d2");												\
    return d0;															\
}
/***********************************************************/

TYPE_VOID(long, B_SFTSNS, $02);

static __inline__ void
LEDMOD(long key, long mode)
{
    asm volatile ("move.l %0,d1\n\t"
		      "move.l %1,d2\n\t"
		      "moveq.l #$0D,d0\n\t"
		      "trap #15"
			: /* no outputs */
			: "ri" (key), "ri" (mode)
			: "d0", "d1", "d2");
}

TYPE_UNI_D1(long, CRTMOD, long, mode, $10);
TYPE_DI_D1D2(long, TPALET, long, palette, long, color, $13);
TYPE_DI_D1D2(long, TPALET2, long, palette, long, color, $14);
TYPE_UNI_D1(long, B_PUTC, long, c, $20);
TYPE_UNI_A1(long, B_PRINT, char *, str, $21);
TYPE_UNI_D1(long, B_COLOR, long, color, $22);
TYPE_DI_D1D2(long, B_LOCATE, long, x, long, y, $23);

static __inline__ void
B_CLR_AL(void)
{
    asm volatile ("move.l #2,d1\n\t"
		      "moveq.l #$2A,d0\n\t"
		      "trap #15"
			: /* no outputs */
			: /* no inputs */
			: "d0", "d1");
}

static __inline__ long
B_CONSOL(long sx, long sy, long xlength, long ylength)
{
    register unsigned int d0 asm("d0");

    asm volatile ("move.w %1,d1\n\t"
		      "swap.w d1\n\t"
		      "move.w %2,d1\n\t"
		      "move.w %3,d2\n\t"
		      "swap.w d2\n\t"
		      "move.w %4,d2\n\t"
		      "moveq.l #$2E,%0\n\t"
		      "trap #15\n\t"
		      "move.l d2,%0"
			: "=d" (d0)
			: "ri" (sx), "ri" (sy), "ri" (xlength), "ri" (ylength)
			: "d1", "d2");

    return d0;
}

static __inline__ long
B_PUTMES(long color, long x, long y, long max, const char *message)
{
    register unsigned int d0 asm("d0");

    asm volatile ("movem.l d3-d4,-(sp)\n\t"
		      "move.l  %1,d1\n\t"
		      "move.l  %2,d2\n\t"
		      "move.l  %3,d3\n\t"
		      "move.l  %4,d4\n\t"
		      "move.l  %5,a1\n\t"
		      "moveq.l #$2F,%0\n\t"
		      "trap #15\n\t"
		      "move.l d2,%0\n\t"
		      "movem.l (sp)+,d3-d4"
			: "=d" (d0)
			: "ri" (color), "ri" (x), "ri" (y), "ri" (max), "g" (message)
			: "d1", "d2", "d3", "d4", "a1");

    return d0;
}

VOID_VOID(MS_INIT, $70);
VOID_VOID(MS_CURON, $71);
VOID_VOID(MS_CUROF, $72);
TYPE_VOID(long, MS_GETDT, $74);
TYPE_VOID(long, MS_CURGT, $75);
long	MS_CURST(long x, long y);/* $76 */
long	MS_LIMIT(long sx, long sy, long ex, long ey);/* $77 */

static __inline__ long
SKEY_MOD(long mode, long x, long y)
{
    register unsigned int d0 asm("d0");

    asm volatile ("move.l %1,d1\n\t"
		      "move.w %2,d2\n\t"
		      "swap.w d2\n\t"
		      "move.w %3,d2\n\t"
		      "moveq.l #$7D,%0\n\t"
		      "trap #15"
			: "=d" (d0)
			: "ri" (mode), "ri" ((short) x), "ri" ((short) y)
			: "d1", "d2");

    return d0;
}

TYPE_VOID(long, ONTIME, $7F);
TYPE_UNI_A1(long, B_BPEEK, int, address, $82);

static __inline__ void
B_WPOKE(int address, long data)
{
    asm volatile ("move.l %0,a1\n\t"
		      "move.l %1,d1\n\t"
		      "moveq.l #$87,d0\n\t"
		      "trap #15"
			: /* no outputs "=m" (*(char *) address) */
			: "g" (address), "ri" (data)
			: "d0", "d1", "a1");
}

VOID_VOID(OS_CURON, $AE);
VOID_VOID(OS_CUROF, $AF);
VOID_UNI_A1(TXXLINE, struct XLINEPTR *, xlineptr, $D3);
VOID_UNI_A1(TXYLINE, struct YLINEPTR *, ylineptr, $D4);

static __inline__ void
TXRASCPY(long position, long linecount, long mode)
{
    asm volatile ("move.l d3,-(sp)\n\t"
		      "move.l %0,d1\n\t"
		      "move.l %1,d2\n\t"
		      "move.l %2,d3\n\t"
		      "moveq.l #$DF,d0\n\t"
		      "trap #15\n\t"
		      "move.l (sp)+,d3"
			: /* no outputs */
			: "ri" (position), "ri" (linecount), "ri" (mode)
			: "d0", "d1", "d2", "d3");
}

#endif
