/*
----------------------------------------
	ISEARCH.C: MicroEMACS 3.10
----------------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "estruct.h"
#include "etype.h"
#include "edef.h"
#include "elang.h"
#include "ekanji.h"
#include "ecall.h"

/*
========================================
	RCS id ̐ݒ
========================================
*/

__asm("	dc.b	'$Id: isearch.c,v 1.4.2.6 1996/10/01 13:50:54 sharl Exp $'\n""	even\n");

/*
========================================
	gpϐ̒`
========================================
*/

static __pcr__ int cmd_offset = 0;
static __pcr__ int cmd_reexecute = -1;
static int cmd_buff[CMDBUFLEN];
static __pcr__ int roll = 0;

/*
========================================
	gp֐̒`
========================================
*/

static int checknext(int, char *, int);
static int echochar(int, int);
static int get_char(void);
static int isearch(int, int);
static int match_pat(char *);
static int promptpattern(char *);
static int scanmore(char *, int);

/*
----------------------------------------
	t isearch
----------------------------------------
*/

int risearch(int f, int n)
{
	int curoff;
	LINE *curline;
	WINDOW *wp = curwp;

	curline = wp->w_dotp;
	curoff = wp->w_doto;
	backchar(TRUE, 1);
	if (isearch(f, -n) == FALSE) {
		wp->w_dotp = curline;
		wp->w_doto = curoff;
		wp->w_flag |= WFMOVE;
		update(FALSE);
		mlwrite(KTEX164);
	} else
		mlerase();

	return TRUE;
}

/*
----------------------------------------
	 isearch
----------------------------------------
*/

int fisearch(int f, int n)
{
	int curoff;
	LINE *curline;
	WINDOW *wp = curwp;

	curline = wp->w_dotp;
	curoff = wp->w_doto;
	if (isearch(f, n) == FALSE) {
		wp->w_dotp = curline;
		wp->w_doto = curoff;
		wp->w_flag |= WFMOVE;
		update(FALSE);
		mlwrite(KTEX164);
	} else
		mlerase();

	return TRUE;
}

/*
========================================
	isearch {
========================================
*/

int isearch(int f, int n)
{
	WINDOW *wp = curwp;
	LINE *curline;
	int status, col, cpos, expc, kan;
	int c, curoff, init_direction;
	char pat_save[NPAT];

	cmd_reexecute = -1;
	cmd_offset = 0;
	cmd_buff[0] = 0;
	strncpy(pat_save, pat, NPAT);

	curline = wp->w_dotp;
	curoff = wp->w_doto;
	init_direction = n;
	roll = 0;
#ifndef MINES
start_over:
#endif
	col = promptpattern(KTEX165);
	cpos = 0;
	status = TRUE;
	expc = get_char();
	c = ectoc(expc);

	if (c == IS_FORWARD1 || c == IS_FORWARD2 || c == IS_REVERSE1 || c == IS_REVERSE2) {
		for (cpos = 0; pat[cpos]; cpos++)
			col = echochar((int) pat[cpos], col);
		if (c == IS_REVERSE1 || c == IS_REVERSE2) {
			n = -1;
			backchar(TRUE, 1);
		} else
			n = 1;
		status = scanmore(pat, n);
		expc = get_char();
		c = ectoc(expc);
	}
	while (1) {
		if (expc == sterm)
			return TRUE;

		kan = 0;
		switch (expc) {
		case CTRL | 'G':
			return FALSE;
		case CTRL | 'N':
#ifndef MINES
		case SPEC | '-':
		case CTRL | 'X':
			if (!isearch_micro)
#endif
				goto add_to_search_string;
		case CTRL | 'S':
			n = 1;
			goto same;
		case CTRL | 'P':
#ifndef MINES
		case SPEC | '&':
		case CTRL | 'E':
			if (!isearch_micro)
#endif
				goto add_to_search_string;
		case CTRL | 'R':
			n = -1;
		  same:
			status = scanmore(pat, n);
			goto next;
		case CTRL | 'Q':
		case CTRL | 'V':
			expc = get_char();
			c = ectoc(expc);
			break;
		case CTRL | 'M':
			c = I_NEWLINE;
			break;
		case CTRL | 'I':
		case CTRL | 'J':
			break;
#ifndef MINES
		case SPEC | '(':
		case CTRL | 'B':
		case 0x7f:
#ifndef MINES
			if (!isearch_micro)
#endif
				goto add_to_search_string;
		case CTRL | 'H':
			if (cmd_offset > 0) {
				cmd_offset -= 2;
				if (cmd_offset > 0) {
					c = ectoc(cmd_buff[cmd_offset - 1]);
					if (iskanji(c)) {
						cmd_offset--;
						if (cmd_offset > 0) {
							c = ectoc(cmd_buff[cmd_offset - 1]);
							if (c == IS_QUOTE || c == IS_68QUOTE)
								cmd_offset--;
						}
					} else if (c == IS_QUOTE || c == IS_68QUOTE)
						cmd_offset--;
				}
				cmd_buff[cmd_offset] = 0;
				wp->w_dotp = curline;
				wp->w_doto = curoff;
				wp->w_flag |= WFMOVE;
				n = init_direction;
				roll = 0;
				strncpy(pat, pat_save, NPAT);
				cmd_reexecute = 0;
			}
			goto start_over;
#endif
		case CTRL | 'F':
#ifndef MINES
			if (isearch_micro)
				goto add_to_search_string;
#endif
			if (n > 0) {
				LINE *lp;
				int cc;

				lp = wp->w_dotp;
				if (llength(lp) != wp->w_doto) {
					c = lgetc(lp, wp->w_doto);
					if (iskanji(c)) {
						if (cpos + 2 >= NPAT - 1) {
							mlwrite(KTEX166);
							if (cmd_reexecute == -1)
								H68beep();
							goto next;
						}
						pat[cpos++] = c;
						col = echochar(c, col);
						cc = lgetc(lp, wp->w_doto + 1);
						pat[cpos++] = cc;
						col = echochar(cc, col);
						pat[cpos] = 0;
						c = (c << 8) + cc;
						goto do_scan;
					}
				} else {
					if (lp == curbp->b_linep) {
						if (cmd_reexecute == -1)
							H68beep();
						goto next;
					}
					c = I_NEWLINE;
				}
				break;
			} else {
				H68beep();
				goto next;
			}
		default:
		  add_to_search_string:
			if (expc & 0xff00) {
#ifndef MINES
				if (!isearch_micro) {
#endif
					isearch_last_key = expc;
					return TRUE;
#ifndef MINES
				}
				goto next;
#endif
			}
			kan = iskanji(c);
			break;
		}

		if (cpos + (kan ? 2 : 1) >= NPAT - 1) {
			mlwrite(KTEX166);
			if (cmd_reexecute == -1)
				H68beep();
			goto next;
		}
		pat[cpos++] = c;
		pat[cpos] = 0;
		col = echochar(c, col);
		if (kan) {
			int cc;

			cc = ectoc(get_char());
			pat[cpos++] = cc;
			pat[cpos] = 0;
			col = echochar(cc, col);
			c = (c << 8) + cc;
		}

	  do_scan:
   		if (!status) {
			if (cmd_reexecute == -1)
				H68beep();
		} else if (!(status = checknext(c, pat, n)))
			status = scanmore(pat, n);

	  next:
		expc = get_char();
		c = ectoc(expc);
	}
}

/*
========================================
	̈ꕶ`FbN
========================================
*/

static int checknext(int chr, char *patrn, int dir)
{
	int curoff;
	LINE *curline;
	WINDOW *wp = curwp;

	curline = wp->w_dotp;
	curoff = wp->w_doto;

	if (dir > 0) {
		int buffchar, status;

		if (curoff == llength(curline)) {
			curline = lforw(curline);
			if (curline == curbp->b_linep)
				return FALSE;
			curoff = 0;
			buffchar = I_NEWLINE;
		} else
			buffchar = lgetc(curline, curoff++);

		if (chr & 0xff00) {
			if (curoff == llength(curline))
				return FALSE;
			buffchar = (buffchar << 8) + lgetc(curline, curoff++);
			status = buffchar == chr;
		} else
			status = eq(buffchar, chr);

		if (status) {
			wp->w_dotp = curline;
			wp->w_doto = curoff;
			wp->w_flag |= WFMOVE;
		}
		return status;
	}
	return match_pat(patrn);
}

/*
========================================
	̃}b`OT
========================================
*/

static int scanmore(char *patrn, int dir)
{
	int status;

	setjtable(patrn);
	status = (dir < 0)
	    ? scanner(tap, REVERSE, PTBEG) : scanner(patrn, FORWARD, PTEND);
	if (status == FALSE) {
		if (roll != dir) {
			if (cmd_reexecute == -1)
				H68beep();
			roll = dir;
		} else {
			int off;
			LINE *lp;
			WINDOW *wp = curwp;

			lp = wp->w_dotp;
			off = wp->w_doto;

			if (dir < 0) {
				wp->w_dotp = curbp->b_linep;
				wp->w_doto = llength(wp->w_dotp);
				status = scanner(tap, REVERSE, PTBEG);
			} else {
				wp->w_dotp = lforw(curbp->b_linep);
				wp->w_doto = 0;
				status = scanner(patrn, FORWARD, PTEND);
			}
			if (status == FALSE) {
				wp->w_dotp = lp;
				wp->w_doto = off;
			}
		}
	} else	roll = 0;
	return status;
}

/*
========================================
	o[Xp}b`OTu
========================================
*/

static int match_pat(char *patrn)
{
	LINE *curline;
	int i, len, curoff;

	curline = curwp->w_dotp;
	curoff = curwp->w_doto;

	len = strlen(patrn);
	for (i = 0; i < len; i++) {
		int buffchar;

		if (curoff == llength(curline)) {
			curline = lforw(curline);
			curoff = 0;
			if (curline == curbp->b_linep)
				return FALSE;
			buffchar = I_NEWLINE;
		} else
			buffchar = lgetc(curline, curoff++);

		if (iskanji(buffchar) && curoff != llength(curline)) {
			if (buffchar != patrn[i++])
				return FALSE;
			if (lgetc(curline, curoff++) != patrn[i])
				return FALSE;
		} else {
			if (!eq(buffchar, patrn[i]))
				return FALSE;
		}
	}

	return TRUE;
}

/*
========================================
	\
========================================
*/

static int promptpattern(char *prompt)
{
	char tpat[NPAT + 20], epat[NPAT + 20];

	expandp(pat, epat, NPAT >> 1);
	sprintf(tpat, "%s [%s]%s: "
		,prompt
		,epat
		,termstr());
	if (!clexec)
		mlwrite(tpat);

	return strlen(tpat);
}

/*
========================================
	\
========================================
*/

static int echochar(int c, int col)
{
	static int lastchar;
	static __pcr__ int lastcharflag = 0;

	if (lastcharflag) {
		lastcharflag = 0;
		c = ((lastchar << 8) | (c & CHARMASK)) & WORDMASK;
		outchar(c);
		outupdate();
		col += 2;
		return col;
	} else if (iskanji(c)) {
		lastcharflag = 1;
		lastchar = c;
		return col;
	}
	if (c < ' ' || c == 0x7f) {
		switch (c) {
		case I_NEWLINE:
			outstring("<NL>");
			col += 3;
			break;
		case TAB:
			outstring("<TAB>");
			col += 4;
			break;
		case 0x7f:
			outstring("^?");
			col++;
			break;
		default:
			outchar('^');
			outchar(c + 0x40);
			col++;
		}
	} else
		outchar(c);

	outupdate();

	return ++col;
}

/*
========================================
	isearch p get_char
========================================
*/

static int get_char(void)
{
	int c;

	if (cmd_reexecute >= 0) {
		c = cmd_buff[cmd_reexecute++];
		if (c)
			return c;
	}
	cmd_reexecute = -1;
	update(FALSE);
	if (cmd_offset >= CMDBUFLEN - 1) {
		mlwrite(KTEX167);
		return sterm;
	}
	c = getkey();
	cmd_buff[cmd_offset++] = c;
	cmd_buff[cmd_offset] = 0;
	return c;
}
